//
// RPCio.hh      : RPC Radio Support Include File
// Authors       : Fabio Silva
//
// Copyright (C) 2000-2002 by the University of Southern California
// $Id: RPCio.hh,v 1.7 2002/06/27 22:04:31 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef _RPCIO_HH_
#define _RPCIO_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 

#include "main/iodev.hh"

#define RPC_DEVICE_FILE "/dev/rpcc"
#define RPC_MSG_PEEK (1 << 30)

class RPCIO : public DiffusionIO {
public:
  RPCIO();
  DiffPacket recvPacket(int fd);
  void sendPacket(DiffPacket pkt, int len, int dst);
};

#endif // !_RPCIO_HH_
