//
// UDPwired.hh   : UDP Wired Support Include File
// Authors       : Chalermek Intanagonwiwat and Fabio Silva
//
// Copyright (C) 2000-2002 by the University of Southern California
// $Id: UDPwired.hh,v 1.7 2002/06/27 22:04:31 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef _UDPWIRED_HH_
#define _UDPWIRED_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <time.h>

#include "main/iodev.hh"

#define RELIABLE_LINK 100
#define MAX_UDP_MESSAGE_SIZE 1500

class TopologyEntry {
public:
  TopologyEntry(){};
  ~TopologyEntry(){};

  int fd_;
  struct sockaddr_in skt_addr_inet_;
  int quality_;
};

typedef list<TopologyEntry *> TopologyList;

class UDPWired : public DiffusionIO {
public:
  UDPWired(char *config_file);
  DiffPacket recvPacket(int fd)
  {
    return NULL;
  };
  void sendPacket(DiffPacket pkt, int len, int dst);

protected:
  TopologyList neighbors_list_;
};

#endif // !_UDPWIRED_HH_
