//
// emstar.hh     : Emstar Include File
// Authors       : Fabio Silva
//
// Copyright (C) 2000-2003 by the University of Southern California
// $Id: emstar.hh,v 1.3 2003/06/06 00:54:08 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef _EMSTAR_HH_
#define _EMSTAR_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 

#include "main/iodev.hh"

#include "emstar_misc.hh"

// Cooked device files
#define EMSTAR_DEVICE "/dev/link/0/data"
#define EMSTAR_DEVICE_PREFIX "/dev/sim"
#define EMSTAR_DEVICE_SUFFIX "/link/0/data"

class RFIdCacheEntry {
public:
  RFIdCacheEntry(int32_t diffusion_id, if_id_t radio_id) :
    diffusion_id_(diffusion_id), radio_id_(radio_id)
  {};
  int32_t diffusion_id_;
  if_id_t radio_id_;
};

typedef list<RFIdCacheEntry *> RFIdCache;

class Emstar : public DiffusionIO {
public:
  Emstar(int32_t node_id = 0, int32_t group_id = 0, bool simulator = false);
  DiffPacket recvPacket(int fd);
  void sendPacket(DiffPacket pkt, int len, int dst);

protected:
  RFIdCache RfCache_;
  void addCache(int32_t diffusion_id, if_id_t radio_id);
  bool findInCache(int32_t diffusion_id, if_id_t *radio_id);
  DiffPacket assemblePacket(if_id_t radio_id, int len, DiffPacket pkt);
};

#endif // !_EMSTAR_HH_
